#include <cassert>
#include <cstdio>
#include <cstring>

const int mod = 1000000007;

long long qpow(long long v, long long st)
{
	long long r = 1;
	while (st)
	{
		if (st&1)
		{
			r = (r * v) % mod;
		}
		v = (v * v) % mod;
		st /= 2;
	}
	return r;
}

long long f[1<<20];

int k;
int a[1<<17];

int main()
{
	f[0] = 1;
	for (int i = 1; i < (1<<20); i++)
	{
		f[i] = f[i - 1] * i;
		if (f[i] >= mod)
			f[i] %= mod;
	}
	
	scanf("%d", &k);
	int sm = 0;
	for (int i = 0; i < k; i++)
	{
		scanf("%d", &a[i]);
		sm += a[i];
	}
	//~ assert(a[0] == 1);
	sm -= a[0];
	
	long long ans = f[sm];
	int odd_count = 0;
	for (int i = 1; i < k; ++i)
	{
		ans *= qpow(f[ a[i] ], mod - 2);
		if (ans >= mod)
			ans %= mod;
		if (a[i] % 2 == 1)
			++odd_count;
	}
	if (odd_count <= 1)
	{
		// also have symmetric dudes. count them.
		sm = 0;
		for (int i = 1; i < k; ++i)
		{
			a[i] /= 2;
			sm += a[i];
		}
		long long b = f[sm];
		for (int i = 1; i < k; ++i)
		{
			b *= qpow(f[ a[i] ], mod - 2);
			if (b >= mod)
				b %= mod;
		}
		ans += b;
	}
	
	ans = ans * qpow(2, mod - 2);
	if (ans >= mod)
		ans %= mod;
	printf("%lld\n", ans);
	return 0;
}
